/**
 * 对 codemirror6 的封装
 */
import { EditorView } from "./setup";
import { Extension } from "@codemirror/state";
import { LanguageSupport } from "@codemirror/language";
import React from "react";
import { JavascriptProps } from "./javascript";
import { JsonProps } from "./json";
import { SqlProps } from "./sql";
import { FormatConfig } from "./format";
export declare type IEditor = EditorView;
export interface CommonProps {
    /**
     * 编辑器的值
     */
    value?: string;
    /**
     * 编辑器初始化使用的值
     */
    defaultValue?: string;
    /**
     * 编辑器内容发生变化触发的回调函数
     */
    onChange?: (value: unknown) => void;
    /**
     * 针对当前输入添加额外的补全候选
     * @deprecated
     */
    extraCompletions?: string[] | ((word: string) => string[] | Promise<string[]>);
    /**
     * 可以配置的主题
     */
    theme?: "dark" | "light";
    /**
     * 是否可编辑
     */
    editable?: boolean;
    /**
     * 拓展方法
     */
    extensions?: (Extension | LanguageSupport)[];
    /**
     * 额外的props
     */
    [key: string]: unknown;
}
export declare type ReactCodemirrorProps = JavascriptProps | JsonProps | SqlProps;
export declare type ReactCodemirrorRefValues = {
    format(configs: FormatConfig): void;
};
interface StaticCodemirrorProps extends CommonProps {
    editable: false;
    onChange: never;
    defaultValue: never;
    language: ReactCodemirrorProps["language"];
    langOptions: ReactCodemirrorProps["langOptions"];
}
declare const _default: React.ForwardRefExoticComponent<Pick<ReactCodemirrorProps | StaticCodemirrorProps, string | number> & React.RefAttributes<ReactCodemirrorRefValues>>;
export default _default;
